Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Interface QLayoutItemInterface

All Superinterfaces:
  QtJambiInterface

All Known Implementing Classes:
  QBoxLayout, QFormLayout, QGridLayout, QHBoxLayout, QLayout, QLayoutItem, QSpacerItem, QStackedLayout, QVBoxLayout, QWidgetItem

    public interface QLayoutItemInterface

extends QtJambiInterface

The `QLayoutItem` class provides an abstract item that a `QLayout` manipulates. This is used by custom layouts.

Pure virtual functions are provided to return information about the layout, including, `sizeHint()`, `minimumSize()`, `maximumSize()` and `expanding()`.

The layout's geometry can be set and retrieved with `setGeometry()` and `geometry()`, and its alignment with `setAlignment()` and `alignment()`.

`isEmpty()` returns whether the layout item is empty. If the concrete item is a `QWidget`, it can be retrieved using `widget()`. Similarly for `layout()` and `spacerItem()`.

Some layouts have width and height interdependencies. These can be expressed using `hasHeightForWidth()`, `heightForWidth()`, and `minimumHeightForWidth()`. For more explanation see the Qt Quarterly article Trading Height for Width.

See also:
  `QLayout`.

Method Summary
`Qt.Alignment` | `alignment()` Returns the alignment of this item.
`QSizePolicy.ControlTypes` | `controlTypes()` Returns the control type(s) for the layout item.
`Qt.Orientations` | `expandingDirections()` Returns whether this layout item can make use of more space than `sizeHint()`.
`QRect` | `geometry()` Returns the rectangle covered by this layout item.
`boolean` | `hasHeightForWidth()` Returns true if this layout's preferred height depends on its width; otherwise returns false.
`int` | `heightForWidth(int arg__1)` Returns the preferred height for this layout item, given the width `w`.
`void` | `invalidate()` Invalidates any cached information in this layout item.
`boolean` | `isEmpty()`
`QLayout` | `layout()` If this item is a `QLayout`, it is returned as a `QLayout`; otherwise 0 is returned.
`QSize` | `maximumSize()` Implemented in subclasses to return the maximum size of this item.
`int` | `minimumHeightForWidth(int arg__1)` Returns the minimum height this widget needs for the given width, `w`.
`QSize` | `minimumSize()` Implemented in subclasses to return the minimum size of this item.
`void` | `setAlignment(Qt.Alignment a)` Sets the alignment of this item to `alignment`.
`void` | `setGeometry(QRect arg__1)`
`QSize` | `sizeHint()` Implemented in subclasses to return the preferred size of this item.
`QSpacerItem` | `spacerItem()` If this item is a `QSpacerItem`, it is returned as a `QSpacerItem`; otherwise 0 is returned.
`QWidget` | `widget()` If this item is a `QWidget`, it is returned as a `QWidget`; otherwise 0 is returned.

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Method Detail

### alignment

    Qt.Alignment alignment()

  Returns the alignment of this item.

See also:
  `setAlignment()`.

### controlTypes

    QSizePolicy.ControlTypes controlTypes()

  Returns the control type(s) for the layout item. For a `QWidgetItem`, the control type comes from the widget's size policy; for a `QLayoutItem`, the control types is derived from the layout's contents.

See also:
  `QSizePolicy::controlType()`.

### setAlignment

    void setAlignment(Qt.Alignment a)

  Sets the alignment of this item to `alignment`.

  Note: Item alignment is only supported by `QLayoutItem` subclasses where it would have a visual effect. Except for `QSpacerItem`, which provides blank space for layouts, all public Qt classes that inherit `QLayoutItem` support item alignment.

See also:
  `alignment()`.

### expandingDirections

    Qt.Orientations expandingDirections()

  Returns whether this layout item can make use of more space than `sizeHint()`. A value of `Qt::Vertical` or `Qt::Horizontal` means that it wants to grow in only one dimension, whereas `Qt::Vertical` | `Qt::Horizontal` means that it wants to grow in both dimensions.

### geometry

    QRect geometry()

  Returns the rectangle covered by this layout item.

See also:
  `setGeometry()`.

### hasHeightForWidth

    boolean hasHeightForWidth()

  Returns true if this layout's preferred height depends on its width; otherwise returns false. The default implementation returns false.

  Reimplement this function in layout managers that support height for width.

See also:
  `heightForWidth()`, and `QWidget::heightForWidth()`.

### heightForWidth

    int heightForWidth(int arg__1)

  Returns the preferred height for this layout item, given the width `w`.

  The default implementation returns -1, indicating that the preferred height is independent of the width of the item. Using the function `hasHeightForWidth()` will typically be much faster than calling this function and testing for -1.

  Reimplement this function in layout managers that support height for width. A typical implementation will look like this:

          public int heightForWidth(int w)
          {
              if (cache_dirty || cached_width != w) {
                  int h = calculateHeightForWidth(w);
                  cached_hfw = h;
                  return h;
              }
              return cached_hfw;
          }

  Caching is strongly recommended; without it layout will take exponential time.

See also:
  `hasHeightForWidth()`.

### invalidate

    void invalidate()

  Invalidates any cached information in this layout item.

### isEmpty

    boolean isEmpty()

### layout

    QLayout layout()

  If this item is a `QLayout`, it is returned as a `QLayout`; otherwise 0 is returned. This function provides type-safe casting.

### maximumSize

    QSize maximumSize()

  Implemented in subclasses to return the maximum size of this item.

### minimumHeightForWidth

    int minimumHeightForWidth(int arg__1)

  Returns the minimum height this widget needs for the given width, `w`. The default implementation simply returns `heightForWidth`(`w`).

### minimumSize

    QSize minimumSize()

  Implemented in subclasses to return the minimum size of this item.

### setGeometry

    void setGeometry(QRect arg__1)

### sizeHint

    QSize sizeHint()

  Implemented in subclasses to return the preferred size of this item.

### spacerItem

    QSpacerItem spacerItem()

  If this item is a `QSpacerItem`, it is returned as a `QSpacerItem`; otherwise 0 is returned. This function provides type-safe casting.

### widget

    QWidget widget()

  If this item is a `QWidget`, it is returned as a `QWidget`; otherwise 0 is returned. This function provides type-safe casting.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD